﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head><title>Fetching Report Data via API</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Fetching Report Data via API</h1>
        <div class="info" MadCap:conditions="Default.v2021X" MadCap:autonum="&lt;b&gt;Info&lt;/b&gt;">
            <p class="note">This capability is available from the Release v2021.0 onwards.</p>
        </div>
        <p>You can create a Run-time Analytics control inside Saviynt and retrieve the report data on demand via an API.</p>
        <p>To fetch the report data, perform the following:</p>
        <ol>
            <li>
                <p>Create a Run-time Analytics control as shown below.</p>
            </li>
        </ol>
        <ol MadCap:continue="true">
            <li>
                <p>   Use the following API call to fetch the report data.&#160;</p>
            </li>
        </ol>
        <p><strong>POST </strong><em>Fetch Runtime Controls Data</em> </p>
        <p><span class="attr">{{url}}/ECM/{{path}}/fetchRuntimeControlsData</span>
        </p>
        <p>This API is used to fetch runtime analytics data from Saviynt Identity Governance and Administration (IGA). The <span class="attr">Authorization</span> must have <span class="attr">Bearer</span> followed by <span class="attr">Token</span>. A single API call can be used to retrieve a maximum of 10000 rows at a time. The max and the offset parameters can be used while fetching large volumes of data via pagination.</p>
        <p><strong>Mandatory params</strong>:</p>
        <p>“analyticsid” or “analyticsname”, “attributes” - runtime control params.&#160;</p>
        <p><strong>Sample query</strong>
        </p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select * from users where manager = ${manager} and username = ${username} "attributes":{ "manager":"4", "username":"johndoe" }    </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p><strong>Optional params</strong>:     </p>
        <p>“max”, “offset”, “loggedinuser”</p>
        <p>&#160; <strong>HEADERS</strong></p>
        <p>Authorization Bearer {{token}}</p>
        <p>Content-Typeapplication/json</p>
        <p><strong>BODY </strong>raw <br />Example Request</p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">curl --location -g --request POST '{{url}}/ECM/{{path}}/fetchRuntimeControlsData' \
--header 'Authorization: Bearer {{token}}' \
--header 'Content-Type: application/json' \
--data-raw '{
    "analyticsid": "11",
    "max": "10",
    "offset": "0",
    "loggedinuser": "admin",
    "attributes": {
        "manager": "4",
        "username": "johndoe"    }
}'    </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>Example Response &#160;</p>
        <div class="codeContent panelContent pdl">
            <MadCap:codeSnippet>
                <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
                <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">{
  "result": [
    {
      "FIRSTNAME": "John",
      "USERNAME": "johndoe"    }
  ],
  "msg": "Success",
  "displaycount": 1,
  "total": 1,
  "errorCode": 0
}
   </MadCap:codeSnippetBody>
            </MadCap:codeSnippet>
            <p>&#160;</p>
        </div>
    </body>
</html>